.\"	$NetBSD: genassym.cf.5,v 1.11 2005/09/11 23:32:48 wiz Exp $
.\"
.\" Copyright (c) 1997 Matthias Pfaller.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd August 18, 2005
.Dt GENASSYM.CF 5
.Os
.Sh NAME
.Nm genassym.cf
.Nd assym.h definition file
.Sh DESCRIPTION
The
.Nm
file is used by
.Xr genassym 1
to make constant C expressions known to assembler source files.
Lines starting with '#' are discarded by
.Xr genassym 1 .
Lines starting with
.Em include ,
.Em ifdef ,
.Em if ,
.Em else
or
.Em endif
are preceded with '#' and passed otherwise unmodified to the C compiler.
Lines starting with
.Em quote
get passed on with the
.Em quote
command removed.
The first word after a
.Em define
command is taken as a CPP identifier and the rest of the line has to be
a constant C expression. The output of
.Xr genassym 1
will assign the numerical value of this expression to the CPP identifier.
.Em "export X"
is a shorthand for
.Em "define X X" .
.Em "struct X"
remembers X for the
.Em member
command and does a
.Em "define X_SIZEOF sizeof(X)" .
.Em "member X"
does a
.Em "define X offsetof(\*[Lt]last struct\*[Gt], X)" .
.Em "config \*[Lt]ctype\*[Gt] \*[Lt]gcc constraint\*[Gt] \*[Lt]asm print modifier\*[Gt]"
can be used to customize the output of
.Xr genassym 1 .
When producing C output, values are casted to \*[Lt]ctype\*[Gt] (default: long)
before they get handed to printf. \*[Lt]gcc constraint\*[Gt] (default: n) is the
constraint used in the __asm__ statements. \*[Lt]asm print modifier\*[Gt] (default:
empty) can be used to force gcc to output operands in different ways
then normal. The "a" modifier e.g. stops gcc from emitting immediate
prefixes in front of constants for the i386 and m68k port.
.Sh FILES
.Pa /usr/src/sys/arch/${MACHINE}/${MACHINE}/genassym.cf
.Sh SEE ALSO
.Xr genassym 1
.Sh HISTORY
The
.Nm
file appeared in
.Nx 1.3 .
